package org.sinev.igor.ps.model;

import java.io.IOException;
import java.io.Writer;
import java.util.List;

import org.sinev.igor.ps.operatordescription.OperatorNamingMap;

/**
 * Interface for PS documents.
 *  
 * @author Igor Sinev
 */
public interface IDocument extends IElementStructure {	
	/**
	 * Acquires the list of document elements.
	 *  
	 * @return list of elements this document is composed from.
	 */
	public List<IElement> getElementsList();
	
	/**
	 * Writes the PS document to the specified Writer.
	 * 
	 * @param w writer to operate with
	 * 
	 * @throws IOException 
	 */
	public void write(Writer w) throws IOException;

	/**
	 * Gets naming map assigned to the document.
	 * 
	 * @return document naming map.
	 */
	public OperatorNamingMap getNamingMap();
}
