package org.sinev.igor.ps.model;

import org.sinev.igor.ps.elementtype.ElementType;

/**
 * Interface for a single element of PS document.
 * 
 * @author Igor Sinev
 */
public interface IElement {		
	/**
	 * Gets string representation of an element.
	 * 
	 * @return original string representation of an element.
	 */
	public String getRepresentation();

	
	/**
	 * Gets type of the element.
	 * 
	 * @return type of the element.
	 */
	public ElementType getType();
}
