package org.sinev.igor.ps.model;

import java.util.List;

import org.sinev.igor.ps.operatordescription.OperatorDescription;

/**
 * Interface for an operator element of a PS document.
 * 
 * @author Igor Sinev
 */
public interface IPSEOperator extends IElement {
	/**
	 * Gets PostScript syntax description bound to the operator.
	 * 
	 * @return operator description.	 
	 */
	public OperatorDescription getDescription();
	
	/**
	 * Gets the list of arguments of this operator.
	 * 
	 * @return arguments list
	 */
	public List<IStackObject> getArguments();
	
	/**
	 * Gets the list of elements this operator returns.
	 * 
	 * @return calculated list of values returned by this operator.
	 */
	public List<IElement> calculateReturns();
}
