package org.sinev.igor.ps.model;

import org.sinev.igor.ps.elementtype.ElementType;

/**
 * Interface for interpretable object, instances of which are stored 
 * on the execution stack.
 * 
 * @author Igor Sinev 
 */
public interface IStackObject {		
	/**
	 * Carries out partial interpretation and returns element 
	 * that will actually be on the stack during program execution.
	 *  
	 * @return elemtent corresponding to this object.
	 */
	public IElement getElement();

	/**
	 * Returns type of this element.
	 * 
	 * @return element type.
	 */
	public ElementType getType();
}
