package org.sinev.igor.ps.model.impl;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IPSEComment;

/**
 * Represents a whitespace element of some PS document.
 * 
 * @author Igor Sinev
 */
public class PSEComment extends Element implements IPSEComment {			
	public PSEComment(String representation, IDocument d) {
		super(representation, d);		
	}
	
	public void listDebugOutput(StringBuffer target) {
		target.append("Comment: ");
		target.append(myRepresentation);
	}
	
	public boolean isInterpretable() {
		return false;
	}

	public ElementType getType() {
		throw new IllegalStateException("Objects of type " + this.getClass().getName() + " can't take part in interpretation data flow as operator arguments");
	}		
}
