package org.sinev.igor.ps.model.impl;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IPSEInteger;

/**
 * Represents an integer element of some PS document.
 * 
 * @author Igor Sinev
 */
public class PSEInteger extends Element implements IPSEInteger {

	private int myValue;
	
	PSEInteger(String representation, IDocument d) {
		super(representation, d);
		myValue = Integer.parseInt(representation);
	}
	
	PSEInteger(int v, IDocument d) {
		super(String.valueOf(v), d);
		myValue = v;
	}
	
	public int getValue() {
		return myValue;
	}
	
	public ElementType getType() {
		return ElementType.INT;
	}
	
	@Override
	public boolean isInterpretable() {
		return true;
	}

	public void setValue(int v) {		
		myRepresentation = String.valueOf(v);
		myValue = v;
	}
}
