package org.sinev.igor.ps.model.impl;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IPSEReal;

/**
 * Represents a real number element of some PS document.
 * 
 * @author Igor Sinev
 */
public class PSEReal extends Element implements IPSEReal {

	private double myValue;
	
	PSEReal(String representation, IDocument d) {
		super(representation, d);
		myValue = Double.parseDouble(representation);
	}
	
	PSEReal(double v, IDocument d) {
		super(String.valueOf(v), d);
		myValue = v;
	}

	/**
	 * Gets the value of an element.
	 * 
	 * @return element value.
	 */
	public double getValue() {
		return myValue;
	}
	
	public ElementType getType() {
		return ElementType.REAL;
	}
	
	@Override
	public boolean isInterpretable() {
		return true;
	}

	public void setValue(double v) {		
		myRepresentation = String.valueOf(v);
		myValue = v;
	}
}
