package org.sinev.igor.ps.reader;

import java.io.IOException;

/**
 * Utility class.
 * Reads characters until specified function reports that 
 * terminator character is reached.
 *  
 * @author Igor Sinev
 */
class TerminatedStringReader {
	static interface TerminatorChecker {
		boolean isTerminator(char c);
	}
	
	static String readUntilTerminator(CountingPushbackReader r, TerminatorChecker c) throws IOException {
		StringBuffer s = new StringBuffer();
		int lci;
		while ((lci = r.read()) != -1) {
			char lc = (char) lci;
			boolean ist = c.isTerminator(lc);			
			if (s.length() > 0 && ist) {
				r.unread(lci);
				break;
			}
			else {
				s.append(lc);
				if (ist)
					break;
			}
		}
		return s.toString();
	}
}
