package org.sinev.igor.ps.tests;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.operatordescription.OperatorNamingMap;

import junit.framework.TestCase;

public class NamingMapTest extends TestCase {
	
	public static OperatorNamingMap createNamingMapStub() {
		OperatorNamingMap m = new OperatorNamingMap();
		m.addDescription(			"add",
						new ElementType[] {ElementType.NUMBER, ElementType.NUMBER},
						new ElementType[] {ElementType.NUMBER},
						"Arithmetic",
						"Calculates sum of two numbers"						
			); 									
		m.addDescription(			"mul",
				new ElementType[] {ElementType.NUMBER, ElementType.NUMBER},
				new ElementType[] {ElementType.NUMBER},
				"Arithmetic",
				"Calculates product of two numbers"			
		);
		m.addDescription(			"pop",
				new ElementType[] {ElementType.INT},
				new ElementType[] {}				
			);
		m.addDescription(			"countexecstack",
				new ElementType[] {},
				new ElementType[] {ElementType.INT}
			);
		m.addDescription(			"flush",
				new ElementType[] {},
				new ElementType[] {}
			);
		
		m.addDescription(			"lineto",
				new ElementType[] {ElementType.NUMBER, ElementType.NUMBER},
				new ElementType[] {},
				"Path construction", 
				"Draw a line to a specified point"
		);
		m.addDescription(			"moveto",
				new ElementType[] {ElementType.NUMBER, ElementType.NUMBER},
				new ElementType[] {},
				"Path construction", 
				"Set current point"						
		);		
		m.addDescription(			"exch",
				new ElementType[] {ElementType.ANY_TYPE, ElementType.ANY_TYPE},
				new ElementType[] {ElementType.ANY_TYPE, ElementType.ANY_TYPE},
				"Stack manipulations", 
				"Exchange two top elements"						
		);
		return m;		
	}
	
	public void testNamingMapCreation() {
		@SuppressWarnings("unused") OperatorNamingMap m = createNamingMapStub();		
	}
}
