package org.sinev.igor.ps.tests;

import java.io.IOException;
import java.io.StringReader;

import junit.framework.TestCase;

import org.sinev.igor.applications.AdditionCalculator;
import org.sinev.igor.ps.PSParseException;
import org.sinev.igor.ps.model.DocumentFactory;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.impl.Element;
import org.sinev.igor.ps.operatordescription.OperatorDescription;
import org.sinev.igor.ps.operatordescription.OperatorNamingMap;
import org.sinev.igor.ps.reader.PSReader;

public class PerformerTest extends TestCase {	

	public static OperatorNamingMap createMapWithAddition() {	
		OperatorNamingMap m = NamingMapTest.createNamingMapStub();	
		OperatorDescription d = m.getDescription("add");
		d.setPerformer(new AdditionCalculator.AdditionPerformer());
		return m;
	}		
		
	public void test1() throws IOException, PSParseException {
		String test = "1 2 add 2.5 3.5 add add";
		DocumentFactory.setNamingMap(createMapWithAddition());
		IDocument d = DocumentFactory.getDocumentFromReader(new PSReader(new StringReader(test)));
		StringBuffer t = new StringBuffer();
		((Element) d.getOutgoingValues().get(0).getElement()).listDebugOutput(t);
		assertEquals(t.toString(), "PSEReal: 9.0");
	}	

}


