package org.sinev.igor.ps.tests;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import junit.framework.TestCase;

import org.sinev.igor.ps.PSParseException;
import org.sinev.igor.ps.model.DocumentFactory;
import org.sinev.igor.ps.model.IReader;
import org.sinev.igor.ps.model.impl.Document;
import org.sinev.igor.ps.model.impl.DocumentDebugWriter;
import org.sinev.igor.ps.reader.PSReader;

public class ReaderTest extends TestCase {	
	
	static {
		DocumentFactory.setNamingMap(NamingMapTest.createNamingMapStub());		
	}
	
	public static void doTest(String in, String outl, String outs) throws IOException, PSParseException {		
		IReader r = new PSReader(new InputStreamReader(new ByteArrayInputStream(in.getBytes())));
		Document d = DocumentFactory.getDocumentFromReader(r);		
		
		//d.debugOutput();
		//d.structureDebugOutput();
		assertEquals(DocumentDebugWriter.listDebugOutputString(d), outl);
		//System.out.println(DocumentDebugWriter.structureDebugOutputString(d));
		assertEquals(DocumentDebugWriter.structureDebugOutputString(d), outs);		
	}
	
	public static void callTest(int i) throws IOException, PSParseException {
		doTest(TestMisc.inputStrings[i], TestMisc.outputStrings[i], TestMisc.structureOutputStrings[i]);
	}
	
	public void test1() throws IOException, PSParseException {		
		callTest(0);
	}	
	
	public void test2() throws IOException, PSParseException {				
		callTest(1);
	}
	
	public void testThrows1() {		
		try {
			doTest("<25> 75 add 200 add", "", "");
			assertFalse("<25> seems to be int", true);
		} catch (IOException e) {
			assertFalse("IO exception", true);
			e.printStackTrace();
		} catch (PSParseException e) {			
			assertEquals(e.getMessage(), "Element type doesn't match: expected NUMBER, found HEXADECIMAL_STRING.");
		}
	}

}


