package org.sinev.igor.psmisc;

//import java.io.BufferedReader;
import java.io.IOException;
//import java.io.Reader;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.operatordescription.OperatorDescription;
import org.sinev.igor.ps.operatordescription.OperatorNamingMap;
import org.sinev.igor.ps.tests.NamingMapTest;
import org.xml.sax.ContentHandler;
import org.xml.sax.DTDHandler;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.AttributesImpl;

class DescriptionFileReader implements XMLReader {
	
	
	ContentHandler handler;
    
 
    String nsu = "";  // NamespaceURI
    AttributesImpl atts = new AttributesImpl();
    String rootElement = "operator-description";
  
    int indent = 0;
    
    public void outputNamingMap(OperatorNamingMap m) throws SAXException {
    	handler.startDocument();
        newLine();
        handler.startElement(nsu, rootElement, rootElement, atts);               
        for (String n : m.getNames())
        	outputOperator(m.getDescription(n));
        
        newLine();
        handler.endElement(nsu, rootElement, rootElement);
        handler.endDocument();
    }

	public void parse(InputSource input) throws IOException, SAXException {
//		Reader r = input.getCharacterStream();	
//        BufferedReader br = new BufferedReader(r);               
        
        outputNamingMap(NamingMapTest.createNamingMapStub());                                               
	}
	
	char[][] whitespace = {"\n".toCharArray(), "\n    ".toCharArray(), "\n        ".toCharArray(), "\n            ".toCharArray()};
	void newLine() throws SAXException {		
		handler.ignorableWhitespace(whitespace[indent], 0, whitespace[indent].length);
	}
	
	void outputOperator(OperatorDescription d) throws SAXException {
		indent++;
		newLine();
		atts.addAttribute(nsu, "name", "name", "ID", d.getName());
		handler.startElement(nsu, "operator", "operator", atts);
		atts.clear();
		if (d.getGroup().length() > 0) {
			outputSimpleElement("group", "name", d.getGroup()); 
		}
		if (d.getComment().length() > 0) {
			indent++;
			newLine();			
			handler.startElement(nsu, "comment", "comment", atts);
			indent++;
			newLine();
			handler.characters(d.getComment().toCharArray(), 0, d.getComment().length());
			indent--;
			newLine();
			handler.endElement(nsu, "comment", "comment");
			indent--;
		}
		for (ElementType t : d.getArguments()) 
			outputSimpleElement("argument", "type", t.toString());
		for (ElementType t : d.getReturns()) 
			outputSimpleElement("return-element", "type", t.toString());
		newLine();
		indent--;		
		handler.endElement(nsu, "operator", "operator");			
	}		
	
	void outputSimpleElement(String name, String attributeName, String attributeValue) throws SAXException {
		indent++;
		newLine();
		atts.addAttribute(nsu, attributeName, attributeName, "CDATA", attributeValue);
		handler.startElement(nsu, name, name, atts);
		atts.clear();
		handler.endElement(nsu, name, name);
		indent--;
	}
	
	public void setContentHandler(ContentHandler handler) {
		this.handler = handler;		
	}

	public ContentHandler getContentHandler() {
		return handler;
	}

	
	

	public boolean getFeature(String name) throws SAXNotRecognizedException, SAXNotSupportedException {
		// TODO Auto-generated method stub
		return false;
	}

	public void setFeature(String name, boolean value) throws SAXNotRecognizedException, SAXNotSupportedException {
		// TODO Auto-generated method stub
		
	}

	public Object getProperty(String name) throws SAXNotRecognizedException, SAXNotSupportedException {
		// TODO Auto-generated method stub
		return null;
	}

	public void setProperty(String name, Object value) throws SAXNotRecognizedException, SAXNotSupportedException {
		// TODO Auto-generated method stub
		
	}

	public void setEntityResolver(EntityResolver resolver) {
		// TODO Auto-generated method stub
		
	}

	public EntityResolver getEntityResolver() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setDTDHandler(DTDHandler handler) {
		// TODO Auto-generated method stub
		
	}

	public DTDHandler getDTDHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setErrorHandler(ErrorHandler handler) {
		// TODO Auto-generated method stub
		
	}

	public ErrorHandler getErrorHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	public void parse(String systemId) throws IOException, SAXException {
		// TODO Auto-generated method stub
		
	}

}
